#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>

#include <rtl_fifo.h>
#include <math.h>

#define LIM 1234567890.

void main(void)
{
	char ch;
	double s, a, sine[3];
	int rtf, cmd, flag = 1;
	if ((rtf = open("/dev/rtf0", O_RDONLY)) < 0) {
		fprintf(stderr, "Error opening /dev/rtf0\n");
		exit(1);
	}
	if ((cmd = open("/dev/rtf1", O_WRONLY)) < 0) {
		fprintf(stderr, "Error opening /dev/rtf0\n");
		exit(1);
	}
	write(cmd, &flag, 4);
	printf("\n***** CHECK FLOATING POINT SUPPORT (TO STOP CTRL-C) *****\n");
	printf("***** PRESS f TO TOGGLE FLOATING POINT SUPPORT AND SEE WHAT HAPPENS *****\n\n");
	printf("***** PRESS ANY OTHER KEY TO KEEP VERIFYING THE CURRENT STATUS *****\n");
	for (s = a = 0.; s < LIM; a += 1., s += a);
	printf("***** THE RIGHT MOST VALUE SHOULD BE%19.10E *****\n\n", s);
	while(1) {
		for (s = a = 0.; s < LIM; a += 1., s += a);
		read(rtf, sine, 16);
		sine[2] = sin(sine[0]);
		printf("%25.16E%25.16E%19.10E\n", sine[1], sine[2], s);
		ch = getchar();
		if (ch == 'f') {
			flag = 1 - flag;
			write(cmd, &flag, 4);
		}
	}
}

