#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>

#include <asm/rt_time.h>
#include <rtl_fifo.h>

#include "common.h"

int main()
{
	int fd0;
	struct sample samp;
	
	if ((fd0 = open("/dev/rtf0", O_RDONLY)) < 0) {
		fprintf(stderr, "Error opening /dev/rtf1\n");
		exit(1);
	}


	while (1) {
		read(fd0, &samp, sizeof(samp));
		printf("*** min: %8d, max: %8d average: %d ***\n", (int) samp.min, (int) samp.max, samp.index);
		fflush(stdout);
	}

	return 0;
}




